use color_eyre::eyre;

mod lib;
use lib::{load, ParseLines};

mod day2;




fn main() -> eyre::Result<()> {
    let data = load("data/02.txt")?;
    day2::part1(&data)?;
    day2::part2(&data)
}


#[allow(dead_code)]
fn day_one() -> eyre::Result<()> {
    let data = load("data/01.txt")?;

    let mut single_increases = 0;
    let mut window_increases = 0;
    let mut prev = (None, None, None);
    for res in data.parse_lines::<i32>() {
        let n = res?;
        if let Some(p) = prev.2 {
            // apparently we can't combine "if let" and regular boolean conditions
            if n > p {
                single_increases += 1;
            }
        }

        if let (Some(first), Some(second), Some(third)) = prev {
            if (n + second + third) > (first + second + third) {
                window_increases += 1;
            }
        }
        // would have forgotten this if not for the warning triggered by "let mut" without mutation
        prev = (prev.1, prev.2, Some(n));
    }

    println!("One: {}", single_increases);
    println!("Two: {}", window_increases);
    Ok(())
}
